const app = getApp()
import $http from './http'
// 获取创建会议室的会议室列表
export function getMeetingRoom(data) {
  return new Promise((resolve, reject) => {
    $http({
      method: 'get',
      data: data,
      url: '/meet/meeting-room/page',
    }).then(res => {
      resolve(res)
    }).catch(err => {
      console.log(res)
    })
  })
}
export function getMeetingGlobalSetting(data) {
  return new Promise((resolve, reject) => {
    $http({
      method: 'get',
      data: data,
      url: '/meet/meeting-global-setting/get',
    }).then(res => {
      resolve(res)
    })
  })
}

// 获取会议室分类
// 办公区域
// OFFICE_LOCATION(0,"meeting_room_location")
// 会议室设施
// OFFICE_FACILITY(1,"meeting_room_facility")
// 会议室分类
// OFFICE_CATEGORY(2,"meeting_room_category")
export function getLabelTree(data) {
  return new Promise((resolve, reject) => {
    $http({
      method: 'get',
      data: data,
      url: '/admin/label/tree',
    }).then(res => {
      resolve(res)
    })
  })
}
// 更新办公区域，设施，分类
export function getMettingRoomLabelUpdate(data) {
  return new Promise((resolve, reject) => {
    $http({
      method: 'POST',
      data: JSON.stringify(data),
      url: '/admin/label/update',
    }).then(res => {
      resolve(res)
    })
  })
}
// 添加办公区域、会议室分类、会议室设置
export function getMettingRoomLabelSave(data) {
  return new Promise((resolve, reject) => {
    $http({
      method: 'POST',
      data: JSON.stringify(data),
      url: '/admin/label/save',
    }).then(res => {
      resolve(res)
    })
  })
}
// 删除办公区域、会议室分类、会议室设置
export function getMettingRoomLabelRemove(data) {
  return $http({
    method: 'get',
    data: data,
    url: `/admin/label/remove/${data}`,
  })
}
// 删除会议室
export function getRemoveMeetingRoom(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting-room/remove/${data}`,
  })
}
// 创建会议室
export function saveMettingRoom(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/save',
  })
}
// 修改会议室
export function mettingRoomUpdate(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/update',
  })
}
// 获取会议室详情
export function getMeetingRoomVOByUuid(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting-room/getMeetingRoomVOByUuid/${data}`,
  })
}
// 获取我的会议
export function myMeetingPage(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting/myPage',
  })
}
// 获取预定会议室列表
export function getReserveRoomList(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: '/meet/meeting-room/queryMeetingRoomAndOccupyTimeSlot',
  })
}

// 获取预定会议详情
export function getMyMeetingDetails(data) {
  return $http({
    method: 'get',
    data: '',
    url: `/meet/meeting/${data}`,
  })
}

// 修改预定时间设置
export function updateGlobalSetting(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/meeting-global-setting/update`
  })
}

// 获取首页信息
export function getHomeUserSchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getHomeUserSchedule`
  })
}

/* 创建日程全部请求 */

// 创建日程
export function addSchedule(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/addSchedule`
  })
}
// 获取参会会人员的日程
export function getUserScheduleInTime(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getUserScheduleInTime`
  })
}
// 获取日程详情
export function getScheduleDetail(data) {
  return $http({
    method: 'post',
    data: JSON.stringify(data),
    url: `/meet/schedule/getScheduleDetail`
  })
}
// 文件上传
export function uploadPermissions() {
  return $http({
    method: 'get',
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace?type=add&ddUserId=${getApp().globalData.userid}`
  })
}
// 文件预览
export function previewPermissions() {
  return $http({
    method: 'get',
    url: `/admin/ddOpenApi/getCustomSpaceAndGrantCustomSpace?type=download&ddUserId=${getApp().globalData.userid}`
  })
}